<?php


namespace Modules\Core\OperationTypes;

use Modules\Core\Models\Operation;
use Modules\Core\Models\User;
use Modules\Core\Payments\ManualPaymentProvider;
use Modules\Core\Services\Contracts\CurrencyServiceInterface;
use Modules\Core\Services\Contracts\UserServiceInterface;

class UserRefillOperationType extends OperationType
{
    public function canCreate(Operation $operation) : bool
    {
        return $operation->payment_system_id; // TODO: Change the autogenerated stub
    }

    public function canCancel(Operation $operation) : bool
    {
        return app('zengine')->modelClass('Operation')::STATUS_CREATED === $operation->status;
    }

    public function canReject(Operation $operation) : bool
    {
        return app('zengine')->modelClass('Operation')::STATUS_CREATED === $operation->status;
    }

    public function canInProgress(Operation $operation) : bool
    {
        return app('zengine')->modelClass('Operation')::STATUS_CREATED === $operation->status;
    }

    /**
     * @param  Operation  $operation
     * @return Operation
     */
    public function create(Operation $operation) : Operation
    {
        $operation = parent::create($operation);

        /* @var $paymentProvider ManualPaymentProvider */
        $paymentProvider = $operation->payment_system->getProvider();
        if (is_array($operation->payment_system->credentials) && count($operation->payment_system->credentials)) {
            $paymentProvider->setCredentials($operation->payment_system->credentials);
        }
        return $paymentProvider->makeRefill($operation);
    }

    /**
     * @param  Operation  $operation
     * @return Operation
     * @throws \Modules\Core\Exceptions\BalanceTypeNotFindException
     * @throws \Modules\Core\Exceptions\OperationWalletInvalidException
     */
    public function success(Operation $operation) : Operation
    {
        if ($operation->target instanceof User) {
            app(UserServiceInterface::class)->putMoney($operation, $operation->target);
        } else {
            app(UserServiceInterface::class)->putMoney($operation);
        }
        $sum = app(CurrencyServiceInterface::class)->convertToDefault(
            $operation->amount,
            $operation->currency
        ) + (float) app('zengine')->getStat('REFILLS_SUCCESS_SUM', 0.00);
        app('zengine')->setStat('REFILLS_SUCCESS_SUM', $sum);
        return parent::success($operation);
    }
}
